/* Entity Hook functions - Copyright (C) 2003 
 * Ravenous Bugblatter Beast <ravenousbugblatterbeast@hotmail.com>
 *
 */

#include <extdll.h>
#include <meta_api.h>

//Functions in entityhook.cpp
void InitEntityHook(HINSTANCE hMetamod,HINSTANCE hGame);
void ShutdownEntityHook();

enginefuncs_t g_engfuncs;
globalvars_t  *gpGlobals;
mutil_funcs_t *gpMetaUtilFuncs;

//Metamod functions? Who needs 'em ;)
static META_FUNCTIONS gMetaFunctionTable = {
	NULL,			// pfnGetEntityAPI				HL SDK; called before game DLL
	NULL,			// pfnGetEntityAPI_Post			META; called after game DLL
	NULL,			// pfnGetEntityAPI2				HL SDK2; called before game DLL
	NULL,			// pfnGetEntityAPI2_Post		META; called after game DLL
	NULL,			// pfnGetNewDLLFunctions		HL SDK2; called before game DLL
	NULL,			// pfnGetNewDLLFunctions_Post	META; called after game DLL
	NULL,			// pfnGetEngineFunctions	META; called before HL engine
	NULL,			// pfnGetEngineFunctions_Post	META; called after HL engine
};

// Description of plugin
plugin_info_t Plugin_info = {
	META_INTERFACE_VERSION,	// ifvers
	"universal",	// name
	"1.00.00",	// version
	"2003/08/27",	// date
	"Ravenous Bugblatter Beast <ravenousbugblatterbeast@hotmail.com>",	// author
	"http://www.ravenousbugblatterbeast.pwp.blueyonder.co.uk/",	// url
	"UNIVERSAL",	// logtag, all caps please
	PT_STARTUP,	// (when) loadable
	PT_STARTUP,	// (when) unloadable
};


//Functions to find the game and metamod module handles

HINSTANCE GetGameDLLModule() {
	char* cp;
	HINSTANCE h=0;

	if((cp=LOCALINFO("mm_gamedll")) && *cp != '\0') {
		char* cf=strrchr(cp, '/');
		if(cf) cf++;
		h=GetModuleHandle(cf);
	}
	if (h==0) {
		LOG_ERROR(PLID, "Universal plugin requires that you use +localinfo mm_gamedll to specific your game mod\n");
	}
	return h;
}

HINSTANCE GetMetamodModule() {
	return GetModuleHandle("metamod.dll");
}


//Metamod API functions

void WINAPI GiveFnptrsToDll( enginefuncs_t* pengfuncsFromEngine, globalvars_t *pGlobals )
{
	memcpy(&g_engfuncs, pengfuncsFromEngine, sizeof(enginefuncs_t));
	gpGlobals = pGlobals;
}

C_DLLEXPORT int Meta_Query(char *, plugin_info_t **pPlugInfo, mutil_funcs_t *pMetaUtilFuncs) {
	*pPlugInfo=&Plugin_info;
	gpMetaUtilFuncs=pMetaUtilFuncs;
	return(TRUE);
}

C_DLLEXPORT int Meta_Attach(PLUG_LOADTIME, META_FUNCTIONS *pFunctionTable, meta_globals_t *pMGlobals,	gamedll_funcs_t *pGamedllFuncs) {
	LOG_MESSAGE(PLID,"'universal' does not need to catch any functions - ignore the warning below\n");
	InitEntityHook(GetMetamodModule(),GetGameDLLModule());
	pFunctionTable=NULL;
	return(TRUE);
}

C_DLLEXPORT int Meta_Detach(PLUG_LOADTIME, PL_UNLOAD_REASON) {
	ShutdownEntityHook();
	return(TRUE);
}



